package xcape;

import JPlay.*;
import java.awt.Color;
import java.awt.Font;
import java.io.FileNotFoundException;
import java.io.IOException;
public class camera extends objetodojogo {
    //A ideia central da camera é ser um objeto de visualização do usuário
    //que possa se mover em um mundo virtual. Assim como todos os objetos(inimigos, jogador, efeitos
    //a camera tambem é um objeto do mundo virtual e possui valores de x e y

    //o elemento principal da camera é a visualização da janela
    Window janela;
    int wid, vid, perg;
    //elementos visuais e de contagem acima e abixo
    Time relogio = new Time(0,0,0,300, 30, new Font("Arial",Font.TRUETYPE_FONT, 30), Color.WHITE, true);
    Sprite zero = new Sprite("Imagem/0.png");
    Sprite um = new Sprite("Imagem/1.png");
    Sprite dois = new Sprite("Imagem/2.png");
    Sprite tres = new Sprite("Imagem/3.png");
    Sprite core = new Sprite("Imagem/core.png");
    scores pontuacao = new scores();
    pergaminho peg = new pergaminho(0,0,0);

    //o metodo construtor da camera que obtem dados importantes para calculos futuros
    camera(double x, double y, int width, int height) {
        super(x, y);
        janela = new Window(width, height);
        wid = (width/2);
    }

    //metodo de desenhar da camera, que calcula a posição e somente exibe os
    //objetos dentro dos dominios do objeto camera
    public void Draw(objetodojogo obj) {
        obj.sprite.x = obj.x - this.x;
        obj.sprite.y = obj.y - this.y;
        obj.sprite.draw();
    }

    //metodo para exibir textos da barra superior da tela
    public void Drawtext()
    {
        janela.drawText("ESCAPE PARA SAIR!", 40, 30, Color.yellow, new Font("Arial",Font.TRUETYPE_FONT, 20));
        janela.drawText(String.valueOf(perg), 530, 30, Color.black, new Font("Arial",Font.TRUETYPE_FONT, 30));
    }

    //retorna o metodo de Input do teclado para ser usado pela classe principal
    public Keyboard getKeyBoard() {
        return janela.getKeyboard();
    }

    //limpa o buffer de video
    public void Clear() {
        janela.clear();
    }

    //metodo de exibir o que foi desenhado na tela
    public void Display() {
        janela.display();
    }

    //metodo para fechar a janela
    public void exit() {
        janela.exit();
    }

    // metodo para sumir com objetos, torna falso qualquer calculo de colisão
    public void Hide(objetodojogo obj) {
        obj.sprite.hide();
    }

    //metodo para fazer objetos voltarem a serem vistos
    public void unHide(objetodojogo obj) {
        obj.sprite.unhide();
    }

    //elimina os dados da jenela da memória
    public void Dispose() {
        janela.dispose();
    }

    //controla o delay da janela
    public void Delay()
    {
        janela.setTimeDelay(6);
    }

    //metodo para fazer a janela seguir um objeto do jogo, no caso o jogador,
    //porem pode ser adptado apra seguir qualquer outro objeto
    public void seguir(objetodojogo obj)
    {
        if ((this.x > 0) && (obj.x < 3610))
            this.x = obj.x-wid;
        if ((this.x < 3200) && (obj.x > 390))
            this.x = obj.x-wid;
    }

    //metodo para configurar elementos visuais de topo de tela
    public void setar()
    {
        tres.setPosition(640, 0);
        dois.setPosition(640, 0);
        um.setPosition(640, 0);
        zero.setPosition(640, 0);
        core.setPosition(700, 0);
        peg.sprite.setPosition(500, 10);
    }

    //metodo que desenha elementos visuais de topo de tela
    //e atualiza dados de controle
    public void fixos(int vidas, int pergaminhos)
    {
        perg = pergaminhos;
        vid = vidas;
        relogio.draw();
        core.draw();
        peg.sprite.draw();
        switch (vid)
        {
            case 3:
                tres.draw();
                break;
            case 2:
                dois.draw();
                break;
            case 1:
                um.draw();
                break;
            default:
                zero.draw();
        }
    }

    //metodo para inserir dados nos Scores
    public void atualizaponto()
    {
        pontuacao.inserir(relogio.getHour(), relogio.getMinute(), relogio.getSecond(), vid, perg);
    }

    //metodo para salvar dados nos Scores no .txt
    public void salvaponto() throws FileNotFoundException, IOException
    {
        pontuacao.salva();
    }

    //metodo para carregar dados de score do .txt
    public void carregaponto() throws FileNotFoundException, IOException
    {
        pontuacao.carregar();
    }
}
